
import java.util.ArrayList;

public class Node {

	public int ID;
	public double FeatureVector[];
	public ArrayList<Integer> ListCircles;
	
	public Node(int id, int numFeatures){
		
		this.ID = id;
		FeatureVector = new double[numFeatures];
		ListCircles = new ArrayList<Integer>();
	}
	
	public void SetFeature(double val, int num){
		
		this.FeatureVector[num] = val;
	}
	
	public void AddToCircle(int circleID){
		
		this.ListCircles.add(Integer.valueOf(circleID));
	}
	
	public void DeleteCircle(int circleID){
		
		int index = this.ListCircles.indexOf(Integer.valueOf(circleID));
		if(index == -1){
			System.out.println("Invalid Remove Author Request : Author :" + this.ID + " Circle:"+ circleID);
		}
		this.ListCircles.remove(index);
				
	}
	
	public double ComputeDistance(Node node2){
		
		double distance = 0.0;		
		int i;
		for(i = 0; i < this.FeatureVector.length; i++){
			distance = distance + (this.FeatureVector[i] - node2.FeatureVector[i])*(this.FeatureVector[i] - node2.FeatureVector[i]);
		}
		
		return Math.sqrt(distance);
	}
	
	public double ComputeSim(Node node2){
		double distance = this.ComputeDistance(node2);
		return 1.0/(1.0 + distance);
	}
	
	
	

}